/*
 * ouvej, determines what, when and where the next lesson will be
 * Copyright (C) 2003 Olivier Mehani <shtrom@ssji.net, olmehani@etu.utc.fr>
 * 
 * $Id: ouvej.c,v 1.15 2004/03/03 18:13:11 shtrom Exp $
 * main and don_t_know_where_to_put_them_elsewhere functions 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <getopt.h>
#include "ouvej.h"

int main(int argc, char **argv, char **envp)
{
	char *homedir, opt;
	bt_t *btree;
	lesson_t right_now;
	int options=0;

	while((opt=getopt(argc,argv,"bhv"))>0) {
		switch(opt) {
		case 'b':
			options+=OPT_DUMP_BTREE;
			break;
		case 'v':
			user_version();
			return 0;
		case 'h':
			user_usage(argv[0]);
			return 0;
		default:
			ERROR("unrecognized switch: use %s -h to see allowed switches\n",argv[0]);
			return 1;
		}
	}

	homedir=get_homedir(envp);

	cache_check(homedir);

	btree=btree_read(cache_path(homedir));
	DDO(btree_show(btree));

	right_now=lesson_from_time(time(NULL));
	__lesson_set_seq(&right_now,get_this_week_sequence());

	if(options & OPT_DUMP_BTREE)
		btree_show(btree);

	user_show_current(right_now);
	user_show_lesson(btree_find_next(btree, right_now),right_now); 
	
	user_clean_ansi();

	return 0;
}
