/*
 * ttd, a time table displayer
 * Copyright (C) 2004 Olivier Mehani <shtrom@ssji.net>
 * 
 * $Id: ttd.h,v 1.1 2004/03/05 16:51:00 shtrom Exp $
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef _TTD_H
#define _TTD_H

#ifdef DEBUG 
# define DPRINT(fmt, args...)	fprintf(stderr,"[%s:%d] %s: "fmt,__FILE__,__LINE__,__FUNCTION__ , ##args)
# define DDO(what)		what
#else
# define DPRINT(fmt, args...)	while(0) /* debug statement */
# define DDO(what)		DPRINT(what)
#endif

#define ERROR(fmt, args...)	fprintf(stderr,"Error: "fmt , ##args)

struct hour {
	int hour;
	int minutes;
};
typedef struct hour hour_t;

enum week_day {
	D_MONDAY,
	D_TUESDAY,
	D_WENESDAY,
	D_THURSDAY,
	D_FRIDAY,
	D_SATURDAY,
	D_SUNDAY,
	D_ERROR
};
typedef enum week_day week_day_t;

enum lesson_type {
	L_C,	/* cours */
	L_D,	/* td */
	L_T,	/* tp */
	L_ERROR
};
typedef enum lesson_type lesson_type_t;

enum week_sequence {
	W_BOTH,
	W_A,
	W_B,
	W_ERROR
};
typedef enum week_sequence week_sequence_t;

#define L_NAME_LEN	32
#define L_PLACE_LEN	8

struct lesson {
	char name[L_NAME_LEN];
	lesson_type_t type;	
	int group;	
	week_day_t day;
	week_sequence_t week_seq;
	hour_t beginning;
	hour_t end;
	char place[L_PLACE_LEN];
};
typedef struct lesson lesson_t;

/* in gtk.c */
GtkWidget *ttd_gtk_mainwin(int n, lesson_t ll[n]);

#endif /* _TTD_H */
