/*
 * ouvej, determines what, when and where the next lesson will be
 * Copyright (C) 2003 Olivier Mehani <shtrom@ssji.net, olmehani@etu.utc.fr>
 * 
 * $Id: week-weak.c,v 1.2 2004/03/05 16:48:11 shtrom Exp $
 * weak a/b week sequence handling, based on a hand filled specified file
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#include <stdio.h>
#define _XOPEN_SOURCE /* see strptime(3) */
#define __USE_XOPEN /* see /usr/include/time.h... */
#include <time.h>
#include "ouvej.h"

#warning check the proper WEEKSEQFILE has been specified

/*
 * little description of the week file
 * this file contains every (seperated) day along with the week they pertain to
 * as it is humain maintained, it is text oriented, the entries are as follow
 * YYYY/MM/DD<TAB>WS
 * the parsing functions are _absolutely_ NOT fault tolerant:
 * 5 single 12 characters (not including LF) per line
 */
week_sequence_t get_this_week_sequence()
{
	FILE *fp;
	char line[14]; /* 12 + newline + line terminator */
	time_t now, current;
	double diff;
	struct tm t;
	DDO(char foo[14]);

	if(!(fp=fopen(WEEKSEQFILE,"r"))) {
		return W_ERROR;
	}
	
	line[13]=0;
	if(fread(line,13,1,fp)<=0) {
		return W_ERROR;
	}

	now=time(NULL);

	strptime(line,"%Y/%m/%d",&t);
	current=mktime(&t);

	diff=difftime(current,now);

	DPRINT("%d %d %f\n",now,current,diff);

	fclose(fp);

	return W_ERROR;
}
